# Generated by Django 4.2.7 on 2023-12-24 16:27

from django.db import migrations
from functools import partial


def change_contenttype(apps, schema_editor, current_ct_name, new_ct_name):
    ContentType = apps.get_model("contenttypes", "ContentType")
    db = schema_editor.connection.alias
    current_ct = ContentType.objects.using(db).filter(app_label="validity", model=current_ct_name).first()
    if not current_ct:
        return
    ContentType.objects.using(db).filter(app_label="validity", model=new_ct_name).delete()
    current_ct.model = new_ct_name
    current_ct.save()


class Migration(migrations.Migration):
    dependencies = [
        ("validity", "0004_netbox35_scripts"),
    ]

    operations = [
        migrations.RunPython(
            migrations.RunPython.noop,
            partial(change_contenttype, current_ct_name="serializer", new_ct_name="configserializer"),
        ),
        migrations.RenameModel(
            old_name="ConfigSerializer",
            new_name="Serializer",
        ),
        migrations.RenameField(
            model_name="serializer",
            old_name="ttp_template",
            new_name="template",
        ),
        migrations.RunPython(
            partial(change_contenttype, current_ct_name="configserializer", new_ct_name="serializer"),
            migrations.RunPython.noop,
        ),
        migrations.AlterModelOptions(
            name="serializer",
            options={"default_permissions": (), "ordering": ("name",)},
        ),
    ]
